import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ListPanel } from "./ListPanel";
import { Size } from "igniteui-react-core";
import { Popup } from "./Popup";
import { NativeUIContent } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { ToolActionType } from "igniteui-react-core";
import { ToolCommandArgument } from "igniteui-react-core";
import { ListPanelTemplateItemUpdatingEventArgs } from "./ListPanelTemplateItemUpdatingEventArgs";
import { ToolActionMeasurementContext } from "./ToolActionMeasurementContext";
import { ToolCommand } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ToolCommandEventArgs } from "./ToolCommandEventArgs";
import { ToolActionInfo } from "igniteui-react-core";
import { ToolPanelOrientation } from "./ToolPanelOrientation";
import { NativeUIGrid } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { ToolPanelContentRefreshedEventArgs } from "./ToolPanelContentRefreshedEventArgs";
import { IExecutionContext } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class ToolPanelView extends Base {
    static $t: Type;
    private p;
    private o;
    constructor();
    r(): any;
    c: ToolPanel;
    x(): void;
    k: DomRenderer;
    n: DomWrapper;
    g: RenderingContext;
    m: DomWrapper;
    v(a: DomRenderer): void;
    aa(): void;
    z(): void;
    u(): void;
    ab(): void;
    private d;
    private ad;
    private e;
    private _gridExternal;
    f(): FontInfo;
    w(): void;
    y(): void;
    t(): void;
    i(): number;
    j(a: string): number;
    h: boolean;
    private l;
    s(a: any, b: (arg1: any) => void): void;
    a(): Popup;
    b(a: NativeUIContent): ToolPanel;
    ac(a: any): Rect;
}
/**
 * @hidden
 */
export declare class ToolAction extends Base implements INotifyPropertyChanged {
    static $t: Type;
    e: ToolPanel;
    get ao(): string;
    private a1;
    b(a: boolean): ToolActionEventDetail;
    g(): ToolCommandArgument;
    az(): string;
    w(): any;
    x(): any;
    private ae;
    get ax(): string;
    set ax(a: string);
    a0(): string;
    private z;
    get ai(): string;
    set ai(a: string);
    private y;
    get af(): string;
    set af(a: string);
    private u;
    get v(): any;
    set v(a: any);
    private k;
    get r(): number;
    set r(a: number);
    private l;
    get s(): number;
    set s(a: number);
    private j;
    get q(): number;
    set q(a: number);
    private m;
    get t(): number;
    set t(a: number);
    get i(): boolean;
    private ad;
    get ar(): string;
    set ar(a: string);
    private ac;
    get ap(): string;
    set ap(a: string);
    private ab;
    get am(): string;
    set am(a: string);
    private aa;
    get ak(): string;
    set ak(a: string);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected a8(a: string, b: any, c: any): void;
    protected get_f(): ToolActionType;
    get f(): ToolActionType;
    protected bc(a: string, b: any, c: any): void;
    ba(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
    bb(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
    a4(a: ToolPanel, b: ToolActionMeasurementContext): void;
    a5(a: ToolPanel, b: ToolActionMeasurementContext): void;
    o(a: ToolPanel, b: ToolActionMeasurementContext): number;
    p(a: ToolPanel, b: ToolActionMeasurementContext): number;
    n(a: ToolPanel, b: ToolActionMeasurementContext): number;
    a9(a: ToolActionEventDetail, b: ToolAction): void;
    private bd;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    private a2;
    h(): boolean;
    private a7;
    private a3;
    performed: (sender: any, args: ToolActionPerformedEventArgs) => void;
    static a(a: ToolActionInfo): ToolAction;
    a6(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionLabel extends ToolAction {
    static $t: Type;
    protected get_f(): ToolActionType;
    private bf;
    private be;
    bb(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionRadio extends ToolAction {
    static $t: Type;
    protected get_f(): ToolActionType;
    bf: string;
    b(a: boolean): ToolActionEventDetail;
    x(): any;
    bg(): void;
    private be;
    o(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private bi;
    private bh;
    bb(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionSeparator extends ToolAction {
    static $t: Type;
    protected get_f(): ToolActionType;
    a5(a: ToolPanel, b: ToolActionMeasurementContext): void;
    private be;
    bb(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionIconButton extends ToolAction {
    static $t: Type;
    protected get_f(): ToolActionType;
    g(): ToolCommandArgument;
    b(a: boolean): ToolActionEventDetail;
    private be;
    o(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private bg;
    private bf;
    bb(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionGroupHeader extends ToolAction {
    static $t: Type;
    protected get_f(): ToolActionType;
    private be;
    bb(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare abstract class ToolActionMenuBase extends ToolAction {
    static $t: Type;
    g(): ToolCommandArgument;
    a6(a: ToolActionInfo): void;
    constructor();
    private bq;
    private bv;
    private bh;
    get actions(): ToolActionCollection;
    set actions(a: ToolActionCollection);
    b(a: boolean): ToolActionEventDetail;
    private bm;
    private be;
    private bk;
    private bl;
    protected bw(): void;
    private bx;
    private bf;
    private bg;
    protected abstract by(): Rect;
    private bu;
    private bt;
    private bj;
    private bo;
    private bn;
    private bs;
    private br;
}
/**
 * @hidden
 */
export declare class ToolActionIconMenu extends ToolActionMenuBase {
    static $t: Type;
    protected get_f(): ToolActionType;
    private bz;
    o(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected by(): Rect;
    private b1;
    private b0;
    bb(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionCheckbox extends ToolAction {
    static $t: Type;
    protected get_f(): ToolActionType;
    b(a: boolean): ToolActionEventDetail;
    x(): any;
    private be;
    o(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private bg;
    private bf;
    bb(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionNumberInput extends ToolAction {
    static $t: Type;
    protected get_f(): ToolActionType;
    x(): any;
    private be;
    o(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private bh;
    bf(): number;
    b(a: boolean): ToolActionEventDetail;
    private bg;
    bb(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionCollection extends ObservableCollection$1<ToolAction> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ToolActionPerformedEventArgs extends Base {
    static $t: Type;
    constructor();
    c: boolean;
    a: ToolActionEventDetail;
    b: ToolActionEventDetailCollection;
}
/**
 * @hidden
 */
export declare class ToolActionEventDetail extends Base {
    static $t: Type;
    a: ToolAction;
    b: ToolActionType;
    d: boolean;
    c: boolean;
    f: number;
    e: Date;
    g: any;
}
/**
 * @hidden
 */
export declare class ToolActionEventDetailCollection extends ObservableCollection$1<ToolActionEventDetail> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ToolPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    l: ToolPanelView;
    p: NativeUIGrid;
    private s;
    private q;
    private get r();
    aq(a: ListPanel): void;
    private ag;
    private ah;
    private ai;
    private f;
    private aj;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private d;
    aw(a: Size): void;
    contentRefreshed: (sender: any, args: ToolPanelContentRefreshedEventArgs) => void;
    get actions(): ToolActionCollection;
    set actions(a: ToolActionCollection);
    constructor();
    private ak;
    private av;
    private t;
    protected a2(): void;
    private an;
    private w;
    private x;
    private v;
    private al;
    u(a: ToolAction): boolean;
    c(a: string): ToolAction;
    y(a: ToolAction): List$1<ToolAction>;
    private as;
    private az;
    private at;
    private a4;
    private ao;
    ap(): void;
    a3(a: ToolAction): void;
    private ar;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private m;
    get n(): FontInfo;
    set n(a: FontInfo);
    o(): FontInfo;
    protected ax(a: string, b: any, c: any): void;
    protected a0(a: string, b: any, c: any): void;
    a: IExecutionContext;
    static a8: Brush;
    private a5;
    get a7(): Brush;
    set a7(a: Brush);
    static a9: Brush;
    a6: Brush;
    private b;
    private z;
    get ba(): Brush;
    set ba(a: Brush);
    static j: ToolPanelOrientation;
    private i;
    get k(): ToolPanelOrientation;
    set k(a: ToolPanelOrientation);
    ay(a: ToolAction, b: ToolCommand): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
}
